//tenzo-m.c

#include <pthread.h>
#include <math.h>
#include "../types/types.h"
#include "tenzo-m.h"
#include "../ia241serial/ia241serial.h"

pthread_mutex_t hMutexTENZO;
struct _TENZO tenzo;

/************************
 * Process of the Tenzo *
 ************************/
void	TENZO_Process(void)
{
	ushort count = 1;
	int res;
	while(pthread_mutex_trylock(&hMutexTENZO) == EBUSY)
	{
		usleep(_TENZOtime_mutex);
	};
	//pthread_mutex_lock(&hMutexTENZO);
	while(tenzo.tenzo.PortOpened)
	{
		//
		while(count < maxdevTENZO)
		{
			res = TENZO_Send(count);
			if(res > 0)
			{
				//pthread_mutex_unlock(&hMutexTENZO);
				usleep(tenzo.tenzo.TimeWait);
				//while(pthread_mutex_trylock(&hMutexTENZO) == EBUSY)
				//{
				//	usleep(_TENZOtime_mutex);
				//};
				//
				TENZO_Recv(count);
				count++;
				break;
			}
			count++;
		}
		//
		pthread_mutex_unlock(&hMutexTENZO);
		usleep(_TENZOsleep);
		while(pthread_mutex_trylock(&hMutexTENZO) == EBUSY)
		{
			usleep(_TENZOtime_mutex);
		};
		//pthread_mutex_lock(&hMutexTENZO);
		if(count >= maxdevTENZO)
			count = 1;
	};
	pthread_mutex_unlock(&hMutexTENZO);
	usleep(_TENZOsleep);
}

/****************
 * sending data *
 ****************/
 int TENZO_Send(ushort addr)
 {
	 int res = 0;
	 if(tenzo.tenzo.dev[addr].data_out)
	 {
		 res = IA241ssend(tenzo.tenzo.NumPort,(BYTE*)(&tenzo.tenzo.dev[addr].buff_out[0]), tenzo.tenzo.dev[addr].size_out);
		 return res;
	 }
	 else if(tenzo.tenzo.dev[addr].repeat_en)
	 {
		 res = IA241ssend(tenzo.tenzo.NumPort,(BYTE*)(&tenzo.tenzo.dev[addr].buff_out_repeat[0]), tenzo.tenzo.dev[addr].size_out_repeat);
	 }
	 return res;
 }
 
/******************
 * receiving data *
 ******************/
 int TENZO_Recv(ushort addr)
 {
	 int res;
	 if(tenzo.tenzo.dev[addr].data_out)
	 {
		res = IA241sNonBlockRead(tenzo.tenzo.NumPort,&tenzo.tenzo.dev[addr].buff_in[0],255);
		tenzo.tenzo.dev[addr].data_out = FALSE;
		if(res > 0)
		{
			tenzo.tenzo.dev[addr].data_in = TRUE;
			tenzo.tenzo.dev[addr].size_in = res;
		}
		return res;
	 };
	 if(tenzo.tenzo.dev[addr].repeat_en)
	 {
		res = IA241sNonBlockRead(tenzo.tenzo.NumPort,&tenzo.tenzo.dev[addr].buff_in_repeat[0],255);
		if(res > 0)
		{
			tenzo.tenzo.dev[addr].data_in_repeat = TRUE;
			tenzo.tenzo.dev[addr].size_in_repeat = res;
		}
	 }
	 return res;
 }

/***********************
 * Opening serial port *
 * for device Tenzo-m  *
 ***********************/
int		TENZO_Open(int port, uint mode, int baud, int stopbit, uint time_wait)
{
	int res = 0;
	//
	if(IA241sopen(port,mode,baud,0,8,stopbit) < 0)
	{
		res = -1;
		return res;
	}
	if(pthread_mutex_init(&hMutexTENZO,NULL) == 0)
	{
		printf("mutexTENZO OK!\r\n");
	}
	else
	{
		printf("mutexTENZO ERR!\r\n");
		getchar();
	}
	pthread_mutex_lock(&hMutexTENZO);
	tenzo.tenzo.PortOpened = TRUE;
	tenzo.tenzo.NumPort = port;
	tenzo.tenzo.TimeWait = time_wait;
	pthread_mutex_unlock(&hMutexTENZO);
	//pthread_attr_init(&tenzo.pthread_attr);
	//pthread_attr_setdetachstate(&tenzo.pthread_attr,PTHREAD_CREATE_DETACHED);
	//pthread_create(&tenzo._TENZOprocess,&tenzo.pthread_attr,(void*) TENZO_Process,NULL);
	pthread_create(&tenzo._TENZOprocess,NULL,(void*) TENZO_Process,NULL);
	//
	return res;
}

/*************************
 * full computing CRC of *
 * receiving of data     *
 *************************/
BYTE TENZO_InCRC(BYTE* DataIn, ushort size)
{
	BYTE crc = 0;
	ushort count = 0;
	if(size < 1)
		return crc;
	while(count < size)
	{
		crc = TENZO_CRCMaker(DataIn[count], crc);
		count++;
	}
	return crc;
}

/************************
 * full comuting CRC of *
 * data for transeiving *
 ************************/
BYTE TENZO_OutCRC(BYTE* DataOut, ushort size)
{
	BYTE crc = 0;
	ushort count = 0;
	if(size < 1)
		return crc;
	do{
		crc = TENZO_CRCMaker(DataOut[count],crc);
		count++;
	}while(count < size);
	DataOut[count -1] = crc;
	return crc;
}

/***************************
 * computing Crack for     *
 * receive and tranceive   *
 * blocks data of tenzo-m  *
 ***************************/
BYTE	TENZO_CRCMaker(BYTE b_input, BYTE b_CRC)
{
		BOOL tmp;
		struct registers	_reg;
		//=== simulator x86 ===
		_reg.al = b_input;
		_reg.ah = b_CRC;
		_reg.cx = 0x08;
		//==== rol al,1 ===
mod1:	if(_reg.al & 0x80)
			_reg.CF = TRUE;
		else
			_reg.CF = FALSE;
		_reg.al = _reg.al << 1;
		if(_reg.CF)
			_reg.al |= 0x01;
		else
			_reg.al &= 0xFE;
		//=== rcl ah,1 ===
		if(_reg.ah & 0x80)
			tmp = TRUE;
		else
			tmp = FALSE;
		_reg.ah = _reg.ah << 1;
		if(_reg.CF)
			_reg.ah |= 0x01;
		else
			_reg.ah &= 0xFE;
		_reg.CF = tmp;
		//=== jnc mod2 ===
		if(!(_reg.CF))
			goto mod2;
		_reg.ah ^= 0x69;
mod2:	_reg.cx--;
		//=== jnz mod1 ===
		if(_reg.cx != 0)
			goto mod1;
		b_CRC = _reg.ah;
	return b_CRC;
}

//=== create the data blocks for tranceive ===
ushort TENZO_CreateSendPKT(BYTE* DatOut, BYTE* TxDat, ushort size)
{
	ushort count_out = 0;
	ushort count_dat = 0;
	BYTE bt;
	TxDat[count_out] = 0xFF;
	count_out++;
	while(count_dat < size)
	{
		bt = DatOut[count_dat];
		TxDat[count_out] = bt;
		count_out++;
		if(bt == 0xFF)
		{
			TxDat[count_out] =0xFE;
			count_out++;
		};
		count_dat++;
	};
	TxDat[count_out] = 0xFF;
	count_out++;
	TxDat[count_out] = 0xFF;
	count_out++;
	//
	return count_out;
}

//=== dissection the data blocks of receiving ===
ushort TENZO_DissectionRecvPKT(BYTE* DataIn, BYTE* RxDat)
{
	ushort size = 0;
	ushort count = 0;
	BYTE bt;
	if(RxDat[count] != 0xFF)
		return size;
	count++;
	while(count < 256)
	{
		bt = RxDat[count];
		if(bt == 0xFF)
		{
			count++;
			if(RxDat[count] != 0xFE)
				break;
		}
		DataIn[size] = bt;
		size++;
		count++;
	}
	return size;
}

//==== BCD to FLOAT ===
float TENZO_BCDtoFLOAT(uint _bcd)
{
	float _float, mn;
	uint p = 0;
	p += (uint)(_bcd & 0x0F);
	p += (uint)(((_bcd >> 4) & 0x0F) * 10);
	p += (uint)(((_bcd >> 8) & 0x0F) * 100);
	p += (uint)(((_bcd >> 12) & 0x0F) * 1000);
	p += (uint)(((_bcd >> 16) & 0x0F) * 10000);
	p += (uint)(((_bcd >> 20) & 0x0F) * 100000);
	_float = (float)(p);
	p = (uint)((_bcd >> 24) & 0x07);
	mn = pow(10.0, (float)(p));
	_float = _float / mn;
	if((_bcd >> 24) & 0x80)
		_float *= -1.0;
	return _float;
}

//==== FLOAT to BCD ===
uint TENZO_FLOATtoBCD(float _float)
{
	uint p, _bcd = 0;
	p = (uint)(_float / 100000.0);
	_bcd |= (p << 20);
	_float -= (float)(p * 100000);
	p = (uint)(_float / 10000.0);
	_bcd |= (p << 16);
	_float -= (float)(p * 10000);
	p = (uint)(_float / 1000.0);
	_bcd |= (p << 12);
	_float -= (float)(p * 1000);
	p = (uint)(_float / 100.0);
	_bcd |= (p << 8);
	_float -= (float)(p * 100);
	p = (uint)(_float / 10.0);
	_bcd |= (p << 4);
	_float -= (float)(p * 10);
	p = (uint)(_float);
	_bcd |= p ;
	return _bcd;
}

/*******************************************
 *     *
 *******************************************/
 /***********************************
  *    *
  ***********************************/
 int TENZO_Cmd_B3(BYTE addr, BYTE* data, int repeat)
 {
	 int res = 0;
	 ushort size,work;
	 BYTE dout[sizeTENZO] = {0};
	 BYTE din[sizeTENZO] = {0};
	 while(pthread_mutex_trylock(&hMutexTENZO) == EBUSY)
	 {
		usleep(_TENZOtime_mutex);
	 };
	 dout[0] = addr;
	 dout[1] = 0xB3;
	 dout[2] = 0x00;
	 TENZO_OutCRC(&dout[0],3);
	 if(repeat < tenzo_repeat_on)
	 {
		size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out[0],3);
		tenzo.tenzo.dev[addr].size_out = size;
		tenzo.tenzo.dev[addr].data_out = TRUE;
		if(repeat == tenzo_repeat_off)
			tenzo.tenzo.dev[addr].repeat_en = FALSE;
		usleep(tenzo.tenzo.TimeWait);
		if(!(tenzo.tenzo.dev[addr].data_in))
		{
			pthread_mutex_unlock(&hMutexTENZO);
			res = -1;
			return res;
		}
		else
			size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in[0]);
		tenzo.tenzo.dev[addr].data_in = FALSE;
	 }
	 else
	 {
		 if(!(tenzo.tenzo.dev[addr].repeat_en))
		 {
			 size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out_repeat[0],3);
			 tenzo.tenzo.dev[addr].size_out_repeat = size;
			 tenzo.tenzo.dev[addr].repeat_en = TRUE;
			 usleep(tenzo.tenzo.TimeWait);
		 };
		 if(!(tenzo.tenzo.dev[addr].data_in_repeat))
		 {
			 pthread_mutex_unlock(&hMutexTENZO);
			 res = -1;
			 return res;
		 }
		 else
			 size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in_repeat[0]);
		tenzo.tenzo.dev[addr].data_in_repeat = FALSE;
	}
	//
	pthread_mutex_unlock(&hMutexTENZO);
	//
	res = size - 3;
	memcpy(data,&din[2],res);
	return res;
 }
 
 /**********************************
  *    *
  **********************************/
 int TENZO_Cmd_B4(BYTE addr, BYTE* data, int repeat)
 {
	int res = 0;
	int count = 0;
	ushort size,work;
	BYTE dout[sizeTENZO] = {0};
	BYTE din[sizeTENZO] = {0};
	while(pthread_mutex_trylock(&hMutexTENZO) == EBUSY)
	{
		usleep(_TENZOtime_mutex);
	};
	dout[0] = addr;
	dout[1] = 0xB4;
	memcpy(&dout[2],data,14);
	dout[16] = 0;
	TENZO_OutCRC(&dout[0],17);
	if(repeat < tenzo_repeat_on)
	 {
		size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out[0],17);
		tenzo.tenzo.dev[addr].size_out = size;
		tenzo.tenzo.dev[addr].data_out = TRUE;
		if(repeat == tenzo_repeat_off)
			tenzo.tenzo.dev[addr].repeat_en = FALSE;
		usleep(tenzo.tenzo.TimeWait);
		if(!(tenzo.tenzo.dev[addr].data_in))
		{
			pthread_mutex_unlock(&hMutexTENZO);
			res = -1;
			return res;
		}
		else
			size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in[0]);
		tenzo.tenzo.dev[addr].data_in = FALSE;
	 }
	 else
	 {
		 if(!(tenzo.tenzo.dev[addr].repeat_en))
		 {
			 size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out_repeat[0],17);
			 tenzo.tenzo.dev[addr].size_out_repeat = size;
			 tenzo.tenzo.dev[addr].repeat_en = TRUE;
			 usleep(tenzo.tenzo.TimeWait);
		 };
		 if(!(tenzo.tenzo.dev[addr].data_in_repeat))
		 {
			 pthread_mutex_unlock(&hMutexTENZO);
			 res = -1;
			 return res;
		 }
		 else
			 size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in_repeat[0]);
		tenzo.tenzo.dev[addr].data_in_repeat = FALSE;
	}
	//
	pthread_mutex_unlock(&hMutexTENZO);
	//
	res = size - 3;
	if(res > 0)
	{
		printf("error TV009 CMD B4 -- code: %u\r\n",din[2]);
	}
	return res;;  
  }
  
 /**********************
  *    *
  **********************/
 int TENZO_Cmd_C2(BYTE addr,BYTE* data, int repeat)
 {
	 int res = 0;
	 ushort size,work;
	 BYTE dout[sizeTENZO] = {0};
	 BYTE din[sizeTENZO] = {0};
	 while(pthread_mutex_trylock(&hMutexTENZO) == EBUSY)
	 {
		usleep(_TENZOtime_mutex);
	 };
	 //pthread_mutex_lock(&hMutexTENZO);
	 dout[0] = addr;
	 dout[1] = 0xC2;
	 dout[2] = 0x00;
	 TENZO_OutCRC(&dout[0],3);
	 if(repeat < tenzo_repeat_on)
	 {
		size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out[0],3);
		tenzo.tenzo.dev[addr].size_out = size;
		tenzo.tenzo.dev[addr].data_out = TRUE;
		if(repeat == tenzo_repeat_off)
			tenzo.tenzo.dev[addr].repeat_en = FALSE;
		usleep(tenzo.tenzo.TimeWait);
		if(!(tenzo.tenzo.dev[addr].data_in))
		{
			pthread_mutex_unlock(&hMutexTENZO);
			res = -1;
			return res;
		}
		else
			size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in[0]);
		tenzo.tenzo.dev[addr].data_in = FALSE;
	 }
	 else
	 {
		 if(!(tenzo.tenzo.dev[addr].repeat_en))
		 {
			 size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out_repeat[0],3);
			 tenzo.tenzo.dev[addr].size_out_repeat = size;
			 tenzo.tenzo.dev[addr].repeat_en = TRUE;
			 usleep(tenzo.tenzo.TimeWait);
		 };
		 if(!(tenzo.tenzo.dev[addr].data_in_repeat))
		 {
			 pthread_mutex_unlock(&hMutexTENZO);
			 res = -1;
			 return res;
		 }
		 else
			 size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in_repeat[0]);
		tenzo.tenzo.dev[addr].data_in_repeat = FALSE;
	}
	//
	pthread_mutex_unlock(&hMutexTENZO);
	//
	res = size - 3;
	memcpy(data,&din[2],res);
	return res;
 }
 

 /***********************
  *    *
  ***********************/
 int TENZO_Cmd_C3(BYTE addr,BYTE* data, int repeat)
 {
	 int res = 0;
	 ushort size,work;
	 BYTE dout[sizeTENZO] = {0};
	 BYTE din[sizeTENZO] = {0};
	 while(pthread_mutex_trylock(&hMutexTENZO) == EBUSY)
	 {
	 	usleep(_TENZOtime_mutex);
	 };
	 //pthread_mutex_lock(&hMutexTENZO);
	 dout[0] = addr;
	 dout[1] = 0xC3;
	 dout[2] = 0x00;
	 TENZO_OutCRC(&dout[0],3);
	 if(repeat < tenzo_repeat_on)
	 {
		size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out[0],3);
		tenzo.tenzo.dev[addr].size_out = size;
		tenzo.tenzo.dev[addr].data_out = TRUE;
		if(repeat == tenzo_repeat_off)
			tenzo.tenzo.dev[addr].repeat_en = FALSE;
		usleep(tenzo.tenzo.TimeWait);
		if(!(tenzo.tenzo.dev[addr].data_in))
		{
			pthread_mutex_unlock(&hMutexTENZO);
			res = -1;
			return res;
		}
		else
			size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in[0]);
		tenzo.tenzo.dev[addr].data_in = FALSE;
	 }
	 else
	 {
		 if(!(tenzo.tenzo.dev[addr].repeat_en))
		 {
			 size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out_repeat[0],3);
			 tenzo.tenzo.dev[addr].size_out_repeat = size;
			 tenzo.tenzo.dev[addr].repeat_en = TRUE;
			 usleep(tenzo.tenzo.TimeWait);
		 };
		 if(!(tenzo.tenzo.dev[addr].data_in_repeat))
		 {
			 pthread_mutex_unlock(&hMutexTENZO);
			 res = -1;
			 return res;
		 }
		 else
			 size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in_repeat[0]);
		tenzo.tenzo.dev[addr].data_in_repeat = FALSE;
	}
	//
	pthread_mutex_unlock(&hMutexTENZO);
	//
	res = size - 3;
	memcpy(data,&din[2],res);
	return res;
 }

 /******************************
  *    *
  ******************************/
 int TENZO_Cmd_CA(BYTE addr,BYTE calling, BYTE* data, int repeat)
 {
	 int res = 0;
	 ushort size,work;
	 BYTE dout[sizeTENZO] = {0};
	 BYTE din[sizeTENZO] = {0};
	 while(pthread_mutex_trylock(&hMutexTENZO) == EBUSY)
	 {
		usleep(_TENZOtime_mutex);
	 };
	 //pthread_mutex_lock(&hMutexTENZO);
	 dout[0] = addr;
	 dout[1] = 0xCA;
	 dout[2] = calling;
	 dout[3] = 0x00;
	 TENZO_OutCRC(&dout[0],4);
	 if(repeat < tenzo_repeat_on)
	 {
		size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out[0],4);
		tenzo.tenzo.dev[addr].size_out = size;
		tenzo.tenzo.dev[addr].data_out = TRUE;
		if(repeat == tenzo_repeat_off)
			tenzo.tenzo.dev[addr].repeat_en = FALSE;
		usleep(tenzo.tenzo.TimeWait);
		if(!(tenzo.tenzo.dev[addr].data_in))
		{
			pthread_mutex_unlock(&hMutexTENZO);
			res = -1;
			return res;
		}
		else
			size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in[0]);
		tenzo.tenzo.dev[addr].data_in = FALSE;
	 }
	 else
	 {
		 if(!(tenzo.tenzo.dev[addr].repeat_en))
		 {
			 size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out_repeat[0],4);
			 tenzo.tenzo.dev[addr].size_out_repeat = size;
			 tenzo.tenzo.dev[addr].repeat_en = TRUE;
			 usleep(tenzo.tenzo.TimeWait);
		 };
		 if(!(tenzo.tenzo.dev[addr].data_in_repeat))
		 {
			 pthread_mutex_unlock(&hMutexTENZO);
			 res = -1;
			 return res;
		 }
		 else
			 size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in_repeat[0]);
		tenzo.tenzo.dev[addr].data_in_repeat = FALSE;
	}
	//
	pthread_mutex_unlock(&hMutexTENZO);
	//
	res = size - 3;
	memcpy(data,&din[2],res);
	return res;
 }

 /*******************************************************
  *       *
  *******************************************************/
 int TENZO_Cmd_D0(BYTE addr, BYTE data, int repeat)
 {
	 int res = 0;
	 ushort size;
	 BYTE dout[sizeTENZO] = {0};
	 BYTE din[sizeTENZO] = {0};
	 while(pthread_mutex_trylock(&hMutexTENZO) == EBUSY)
	 {
	 	usleep(_TENZOtime_mutex);
	 };
	 dout[0] = addr;
	 dout[1] = 0xD0;
	 dout[2] = data;
	 dout[3] = 0x00;
	 TENZO_OutCRC(&dout[0],4);
	  if(repeat < tenzo_repeat_on)
	 {
		size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out[0],4);
		tenzo.tenzo.dev[addr].size_out = size;
		tenzo.tenzo.dev[addr].data_out = TRUE;
		if(repeat == tenzo_repeat_off)
			tenzo.tenzo.dev[addr].repeat_en = FALSE;
		usleep(tenzo.tenzo.TimeWait);
		if(!(tenzo.tenzo.dev[addr].data_in))
		{
			pthread_mutex_unlock(&hMutexTENZO);
			return res;
		}
		else
			size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in[0]);
	 }
	 else
	 {
		 if(!(tenzo.tenzo.dev[addr].repeat_en))
		 {
			 size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out_repeat[0],4);
			 tenzo.tenzo.dev[addr].size_out_repeat = size;
			 tenzo.tenzo.dev[addr].repeat_en = TRUE;
			 usleep(tenzo.tenzo.TimeWait);
		 };
		 if(!(tenzo.tenzo.dev[addr].data_in_repeat))
		 {
			 pthread_mutex_unlock(&hMutexTENZO);
			 return res;
		 }
		 else
			 size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in_repeat[0]);
	}
	//
	pthread_mutex_unlock(&hMutexTENZO);
	//
	return res;
 }

 int TENZO_Cmd_D0_11(BYTE addr, BYTE data, int repeat)
 {
	 int res = 0;
	 ushort size;
	 BYTE dout[sizeTENZO] = {0};
	 BYTE din[sizeTENZO] = {0};
	 while(pthread_mutex_trylock(&hMutexTENZO) == EBUSY)
	 {
	 	usleep(_TENZOtime_mutex);
	 };
	 dout[0] = addr;
	 dout[1] = 0xD0;
	 dout[2] = data;
	 dout[3] = data;
	 dout[4] = data;
	 dout[5] = data;
	 dout[6] = 0x00;
	 TENZO_OutCRC(&dout[0],7);
	  if(repeat < tenzo_repeat_on)
	 {
		size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out[0],7);
		tenzo.tenzo.dev[addr].size_out = size;
		tenzo.tenzo.dev[addr].data_out = TRUE;
		if(repeat == tenzo_repeat_off)
			tenzo.tenzo.dev[addr].repeat_en = FALSE;
		usleep(tenzo.tenzo.TimeWait);
		if(!(tenzo.tenzo.dev[addr].data_in))
		{
			pthread_mutex_unlock(&hMutexTENZO);
			return res;
		}
		else
			size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in[0]);
	 }
	 else
	 {
		 if(!(tenzo.tenzo.dev[addr].repeat_en))
		 {
			 size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out_repeat[0],7);
			 tenzo.tenzo.dev[addr].size_out_repeat = size;
			 tenzo.tenzo.dev[addr].repeat_en = TRUE;
			 usleep(tenzo.tenzo.TimeWait);
		 };
		 if(!(tenzo.tenzo.dev[addr].data_in_repeat))
		 {
			 pthread_mutex_unlock(&hMutexTENZO);
			 return res;
		 }
		 else
			 size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in_repeat[0]);
	}
	//
	pthread_mutex_unlock(&hMutexTENZO);
	//
	return res;
 }



//=====      ====
int TENZO_Cmd_D3(BYTE addr, BYTE *data, int repeat)
 {
	 int res = 0;
	 ushort size;
	 BYTE dout[sizeTENZO] = {0};
	 BYTE din[sizeTENZO] = {0};
	 while(pthread_mutex_trylock(&hMutexTENZO) == EBUSY)
	 {
	 	usleep(_TENZOtime_mutex);
	 };
	 dout[0] = addr;
	 dout[1] = 0xD3;
	 memcpy(&dout[2],data,10);
	 dout[12] = 0x00;
	 TENZO_OutCRC(&dout[0],13);
	  if(repeat < tenzo_repeat_on)
	 {
		size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out[0],13);
		tenzo.tenzo.dev[addr].size_out = size;
		tenzo.tenzo.dev[addr].data_out = TRUE;
		if(repeat == tenzo_repeat_off)
			tenzo.tenzo.dev[addr].repeat_en = FALSE;
		usleep(tenzo.tenzo.TimeWait);
		if(!(tenzo.tenzo.dev[addr].data_in))
		{
			pthread_mutex_unlock(&hMutexTENZO);
			return res;
		}
		else
			size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in[0]);
	 }
	 else
	 {
		 if(!(tenzo.tenzo.dev[addr].repeat_en))
		 {
			 size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out_repeat[0],13);
			 tenzo.tenzo.dev[addr].size_out_repeat = size;
			 tenzo.tenzo.dev[addr].repeat_en = TRUE;
			 usleep(tenzo.tenzo.TimeWait);
		 };
		 if(!(tenzo.tenzo.dev[addr].data_in_repeat))
		 {
			 pthread_mutex_unlock(&hMutexTENZO);
			 return res;
		 }
		 else
			 size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in_repeat[0]);
	}
	//
	pthread_mutex_unlock(&hMutexTENZO);
	//
	return res;
 }



/***************************
 *   *
 ***************************/
 //====   ====
 int TENZO_Cmd_DF_00(BYTE addr,int repeat)
 {
	 int res = 0;
	 ushort size,work;
	 BYTE dout[sizeTENZO] = {0};
	 BYTE din[sizeTENZO] = {0};
	 while(pthread_mutex_trylock(&hMutexTENZO) == EBUSY)
	 {
		usleep(_TENZOtime_mutex);
	 };
	 //pthread_mutex_lock(&hMutexTENZO);
	 dout[0] = addr;
	 dout[1] = 0xDF;
	 dout[2] = 0x00;
	 dout[3] = 0x00;
	 TENZO_OutCRC(&dout[0],4);
	 if(repeat < tenzo_repeat_on)
	 {
		size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out[0],4);
		tenzo.tenzo.dev[addr].size_out = size;
		tenzo.tenzo.dev[addr].data_out = TRUE;
		if(repeat == tenzo_repeat_off)
			tenzo.tenzo.dev[addr].repeat_en = FALSE;
		usleep(tenzo.tenzo.TimeWait);
		if(!(tenzo.tenzo.dev[addr].data_in))
		{
			pthread_mutex_unlock(&hMutexTENZO);
			return res;
		}
		else
			size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in[0]);
	 }
	 else
	 {
		 if(!(tenzo.tenzo.dev[addr].repeat_en))
		 {
			 size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out_repeat[0],4);
			 tenzo.tenzo.dev[addr].size_out_repeat = size;
			 tenzo.tenzo.dev[addr].repeat_en = TRUE;
			 usleep(tenzo.tenzo.TimeWait);
		 };
		 if(!(tenzo.tenzo.dev[addr].data_in_repeat))
		 {
			 pthread_mutex_unlock(&hMutexTENZO);
			 return res;
		 }
		 else
			 size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in_repeat[0]);
	}
	//
	pthread_mutex_unlock(&hMutexTENZO);
	//
	return res;
 }

 
 //====   ====
 int TENZO_Cmd_DF_01(BYTE addr,int repeat)
 {
	 int res = 0;
	 ushort size,work;
	 BYTE dout[sizeTENZO] = {0};
	 BYTE din[sizeTENZO] = {0};
	 while(pthread_mutex_trylock(&hMutexTENZO) == EBUSY)
	 {
		usleep(_TENZOtime_mutex);
	 };
	 //pthread_mutex_lock(&hMutexTENZO);
	 dout[0] = addr;
	 dout[1] = 0xDF;
	 dout[2] = 0x01;
	 dout[3] = 0x00;
	 TENZO_OutCRC(&dout[0],4);
	 if(repeat < tenzo_repeat_on)
	 {
		size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out[0],4);
		tenzo.tenzo.dev[addr].size_out = size;
		tenzo.tenzo.dev[addr].data_out = TRUE;
		if(repeat == tenzo_repeat_off)
			tenzo.tenzo.dev[addr].repeat_en = FALSE;
		usleep(tenzo.tenzo.TimeWait);
		if(!(tenzo.tenzo.dev[addr].data_in))
		{
			pthread_mutex_unlock(&hMutexTENZO);
			return res;
		}
		else
			size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in[0]);
	 }
	 else
	 {
		 if(!(tenzo.tenzo.dev[addr].repeat_en))
		 {
			 size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out_repeat[0],4);
			 tenzo.tenzo.dev[addr].size_out_repeat = size;
			 tenzo.tenzo.dev[addr].repeat_en = TRUE;
			 usleep(tenzo.tenzo.TimeWait);
		 };
		 if(!(tenzo.tenzo.dev[addr].data_in_repeat))
		 {
			 pthread_mutex_unlock(&hMutexTENZO);
			 return res;
		 }
		 else
			 size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in_repeat[0]);
	}
	//
	pthread_mutex_unlock(&hMutexTENZO);
	//
	return res;
 }

 //====   ====
 int TENZO_Cmd_DF_02(BYTE addr,int repeat)
 {
	 int res = 0;
	 ushort size,work;
	 BYTE dout[sizeTENZO] = {0};
	 BYTE din[sizeTENZO] = {0};
	 while(pthread_mutex_trylock(&hMutexTENZO) == EBUSY)
	 {
		usleep(_TENZOtime_mutex);
	 };
	 //pthread_mutex_lock(&hMutexTENZO);
	 dout[0] = addr;
	 dout[1] = 0xDF;
	 dout[2] = 0x02;
	 dout[3] = 0x00;
	 TENZO_OutCRC(&dout[0],4);
	 if(repeat < tenzo_repeat_on)
	 {
		size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out[0],4);
		tenzo.tenzo.dev[addr].size_out = size;
		tenzo.tenzo.dev[addr].data_out = TRUE;
		if(repeat == tenzo_repeat_off)
			tenzo.tenzo.dev[addr].repeat_en = FALSE;
		usleep(tenzo.tenzo.TimeWait);
		if(!(tenzo.tenzo.dev[addr].data_in))
		{
			pthread_mutex_unlock(&hMutexTENZO);
			return res;
		}
		else
			size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in[0]);
	 }
	 else
	 {
		 if(!(tenzo.tenzo.dev[addr].repeat_en))
		 {
			 size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out_repeat[0],4);
			 tenzo.tenzo.dev[addr].size_out_repeat = size;
			 tenzo.tenzo.dev[addr].repeat_en = TRUE;
			 usleep(tenzo.tenzo.TimeWait);
		 };
		 if(!(tenzo.tenzo.dev[addr].data_in_repeat))
		 {
			 pthread_mutex_unlock(&hMutexTENZO);
			 return res;
		 }
		 else
			 size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in_repeat[0]);
	}
	//
	pthread_mutex_unlock(&hMutexTENZO);
	//
	return res;
 }

 //====   ====
 int TENZO_Cmd_DF_03(BYTE addr,int repeat)
 {
	 int res = 0;
	 ushort size,work;
	 BYTE dout[sizeTENZO] = {0};
	 BYTE din[sizeTENZO] = {0};
	 while(pthread_mutex_trylock(&hMutexTENZO) == EBUSY)
	 {
		usleep(_TENZOtime_mutex);
	 };
	 //pthread_mutex_lock(&hMutexTENZO);
	 dout[0] = addr;
	 dout[1] = 0xDF;
	 dout[2] = 0x03;
	 dout[3] = 0x00;
	 TENZO_OutCRC(&dout[0],4);
	 if(repeat < tenzo_repeat_on)
	 {
		size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out[0],4);
		tenzo.tenzo.dev[addr].size_out = size;
		tenzo.tenzo.dev[addr].data_out = TRUE;
		if(repeat == tenzo_repeat_off)
			tenzo.tenzo.dev[addr].repeat_en = FALSE;
		usleep(tenzo.tenzo.TimeWait);
		if(!(tenzo.tenzo.dev[addr].data_in))
		{
			pthread_mutex_unlock(&hMutexTENZO);
			return res;
		}
		else
			size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in[0]);
	 }
	 else
	 {
		 if(!(tenzo.tenzo.dev[addr].repeat_en))
		 {
			 size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out_repeat[0],4);
			 tenzo.tenzo.dev[addr].size_out_repeat = size;
			 tenzo.tenzo.dev[addr].repeat_en = TRUE;
			 usleep(tenzo.tenzo.TimeWait);
		 };
		 if(!(tenzo.tenzo.dev[addr].data_in_repeat))
		 {
			 pthread_mutex_unlock(&hMutexTENZO);
			 return res;
		 }
		 else
			 size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in_repeat[0]);
	}
	//
	pthread_mutex_unlock(&hMutexTENZO);
	//
	return res;
 }
 
 //====    ====
 int TENZO_Cmd_DF_05(BYTE addr,int repeat)
 {
	 int res = 0;
	 ushort size,work;
	 BYTE dout[sizeTENZO] = {0};
	 BYTE din[sizeTENZO] = {0};
	 while(pthread_mutex_trylock(&hMutexTENZO) == EBUSY)
	 {
		usleep(_TENZOtime_mutex);
	 };
	 //pthread_mutex_lock(&hMutexTENZO);
	 dout[0] = addr;
	 dout[1] = 0xDF;
	 dout[2] = 0x05;
	 dout[3] = 0x00;
	 TENZO_OutCRC(&dout[0],4);
	 if(repeat < tenzo_repeat_on)
	 {
		size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out[0],4);
		tenzo.tenzo.dev[addr].size_out = size;
		tenzo.tenzo.dev[addr].data_out = TRUE;
		if(repeat == tenzo_repeat_off)
			tenzo.tenzo.dev[addr].repeat_en = FALSE;
		usleep(tenzo.tenzo.TimeWait);
		if(!(tenzo.tenzo.dev[addr].data_in))
		{
			pthread_mutex_unlock(&hMutexTENZO);
			return res;
		}
		else
			size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in[0]);
	 }
	 else
	 {
		 if(!(tenzo.tenzo.dev[addr].repeat_en))
		 {
			 size = TENZO_CreateSendPKT(&dout[0], &tenzo.tenzo.dev[addr].buff_out_repeat[0],4);
			 tenzo.tenzo.dev[addr].size_out_repeat = size;
			 tenzo.tenzo.dev[addr].repeat_en = TRUE;
			 usleep(tenzo.tenzo.TimeWait);
		 };
		 if(!(tenzo.tenzo.dev[addr].data_in_repeat))
		 {
			 pthread_mutex_unlock(&hMutexTENZO);
			 return res;
		 }
		 else
			 size = TENZO_DissectionRecvPKT(&din[0],&tenzo.tenzo.dev[addr].buff_in_repeat[0]);
	}
	//
	pthread_mutex_unlock(&hMutexTENZO);
	//
	return res;
 }



