//tenzo-m.h

#ifndef _tenzo_m_h
#define _tenzo_m_h

#include <pthread.h>
#include "../types/types.h"

#define _TENZOtime_mutex 100
#define _TENZOsleep 1000
#define sizeTENZO 0xFF
#define maxdevTENZO 0x9F
/**********************
 * parametrs of ports *
 **********************/
#define tenzo_repeat_on		1
#define tenzo_repeat_no		0
#define tenzo_repeat_off	-1

struct registers
{
	BOOL 	CF;
	//
	BYTE	al;
	BYTE	ah;
	ushort	cx;
};

struct TENZO_one_dev
{
	BOOL		repeat_en;
	ushort		size_out_repeat;
	BYTE		buff_out_repeat[sizeTENZO];
	BOOL 		data_in_repeat;
	ushort		size_in_repeat;
	ushort		in_len_repeat;
	BYTE		buff_in_repeat[sizeTENZO];
	BOOL 		data_out;
	ushort		size_out;
	BYTE		buff_out[sizeTENZO];
	BOOL 		data_in;
	ushort		size_in;
	ushort		in_len;
	BYTE		buff_in[sizeTENZO];
};

struct OneTENZO
{
	BOOL	PortOpened;
	BOOL	ImpossPort;
	int		NumPort;
	uint	TimeWait;
	struct	TENZO_one_dev	dev[maxdevTENZO];
};

struct _TENZO
{
	pthread_t	_TENZOprocess;
	//pthread_attr_t			pthread_attr;
	struct OneTENZO	tenzo;
};

void		TENZO_Process(void);
int			TENZO_Send(ushort);
int			TENZO_Recv(ushort);
int			TENZO_Open(int,uint,int,int,uint);
BYTE 		TENZO_InCRC(BYTE*,ushort);
BYTE 		TENZO_OutCRC(BYTE*,ushort);
BYTE		TENZO_CRCMaker(BYTE,BYTE);
ushort 		TENZO_CreateTransPKT(BYTE*,BYTE*,ushort);
ushort 		TENZO_DissectionRecvPKT(BYTE*,BYTE*);
float 		TENZO_BCDtoFLOAT(uint);
uint 		TENZO_FLOATtoBCD(float);
int 		TENZO_Cmd_B3(BYTE,BYTE*,int);
int 		TENZO_Cmd_B4(BYTE,BYTE*,int);
int 		TENZO_Cmd_C2(BYTE,BYTE*,int);
int 		TENZO_Cmd_C3(BYTE,BYTE*,int);
int 		TENZO_Cmd_CA(BYTE,BYTE,BYTE*,int);
int 		TENZO_Cmd_D0(BYTE,BYTE,int);
int 		TENZO_Cmd_D0_11(BYTE,BYTE,int);
int 		TENZO_Cmd_D3(BYTE,BYTE*,int);
int 		TENZO_Cmd_DF_00(BYTE,int);
int 		TENZO_Cmd_DF_01(BYTE,int);
int 		TENZO_Cmd_DF_02(BYTE,int);
int 		TENZO_Cmd_DF_03(BYTE,int);
int 		TENZO_Cmd_DF_05(BYTE,int);


#endif
