//tv-009.c

#include <stdio.h>
#include "tv-009.h"
#include "tenzo-m.h"
#include "../types/types.h"

float TV_009_RdMass_brutto(BYTE addr, int repeat)
{
	float mb = -999.0;
	int res;
	int count = 0;
	BYTE data[8];
	//
	res = TENZO_Cmd_C3(addr,&data[0],repeat);
	if(res < 0)
		return mb;
	mb = TENZO_BCDtoFLOAT((*(uint*)(&data[0])));
	//
	return mb;
}

int TV_009_RdFull(BYTE addr, struct _tv_009_full_in* str, int repeat)
{
	int res = 0;
	int count = 0;
	//
	BYTE data[sizeTENZO];
	res = TENZO_Cmd_CA(addr,_rd9_cpl, &data[0], repeat);
	str->mass = TENZO_BCDtoFLOAT((*(uint*)(&data[_addr9_mass])));
	str->inmask = data[_addr9_inp];
	str->outmask = data[_addr9_out];
	str->statmask = data[_addr9_stat];
	//
	if(!(str->inmask & _in9_start))
		str->in_start = TRUE;
	else
		str->in_start = FALSE;
	//
	if(!(str->inmask & _in9_stop))
		str->in_stop = TRUE;
	else
		str->in_stop = FALSE;
	//
	if(!(str->inmask & _in9_closed_unload))
		str->in_closed_unload = TRUE;
	else
		str->in_closed_unload = FALSE;
	//
	if(!(str->inmask & _in9_closed_load_nonprecs))
		str->in_closed_load_nonprecs = TRUE;
	else
		str->in_closed_load_nonprecs = FALSE;
	//
	if(!(str->inmask & _in9_sens_p_aero))
		str->in_sens_p_aero = TRUE;
	else
		str->in_sens_p_aero = FALSE;
	//
	if(!(str->inmask & _in9_sens_l_up))
		str->in_sens_l_up = TRUE;
	else
		str->in_sens_l_up = FALSE;
	//
	if(str->inmask & _in9_opened_load_presc)
		str->in_opened_load_presc = TRUE;
	else
		str->in_opened_load_presc = FALSE;
	//==========
	if(str->outmask & _out9_start)
		str->out_start = TRUE;
	else
		str->out_start = FALSE;
	//
	if(!(str->outmask & _out9_stop))
		str->out_stop = TRUE;
	else
		str->out_stop = FALSE;
	//
	if(!(str->outmask & _out9_unload)) // 
		str->out_closed_unload = TRUE;
	else
		str->out_closed_unload = FALSE;
	//
	if(!(str->inmask & _out9_dosed))
		str->out_dosed = TRUE;
	else
		str->out_dosed = FALSE;
	//
	
	//======
	if(str->statmask & _stat9_restart)
		str->stat_restart = TRUE;
	else
		str->stat_restart = FALSE;
	//
	if(str->statmask & _stat9_err)
		str->stat_err = TRUE;
	else
		str->stat_err = FALSE;
	//
	if(str->statmask & _stat9_netto)
		str->stat_netto = TRUE;
	else
		str->stat_netto = FALSE;
	//
	if(str->statmask & _stat9_keyon)
		str->stat_keyon = TRUE;
	else
		str->stat_keyon = FALSE;
	//
	if(!(str->statmask & _stat9_end_dosator))
		str->stat_end_dosator = TRUE;
	else
		str->stat_end_dosator = FALSE;
	//
	if(!(str->statmask & _stat9_fix_mass_of_inp))
		str->stat_fix_mass_of_inp = TRUE;
	else
		str->stat_fix_mass_of_inp = FALSE;
	/*printf("\r\n");
	while(count < 8)
	{
		printf("%u ",data[count]);
		count++;
	};
	printf("\r\n");*/
	return res;
}

int TV_009_Stop(BYTE addr, int repeat)
{
	int res = 0;
	res = TENZO_Cmd_DF_00(addr,repeat);
	return res;
}

int TV_009_Pause(BYTE addr, int repeat)
{
	int res = 0;
	res = TENZO_Cmd_DF_02(addr,repeat);
	return res;
}


int TV_009_Start(BYTE addr, int repeat)
{
	int res = 0;
	res = TENZO_Cmd_DF_01(addr,repeat);
	return res;
}

BYTE TV_OO9_OpenUnload(BYTE def_outmask)
{
	return(def_outmask & (~(_out9_unload)));
}

BYTE TV_OO9_CloseUnload(BYTE def_outmask)
{
	return(def_outmask | _out9_unload);
}

BYTE TV_OO9_LampStopON(BYTE def_outmask)
{
	return(def_outmask & (~(_out9_stop)));
}

BYTE TV_OO9_LampStopOFF(BYTE def_outmask)
{
	return(def_outmask | _out9_stop);
}


int TV_009_SetOutput(BYTE addr, BYTE def_outmask, int repeat)
{
	int res = 0;
	res = TENZO_Cmd_D0(addr,def_outmask, repeat);
	return res;
}

int TV_009_RdSettings(BYTE addr, struct	_tv_009_set* set, int repeat)
{
	int res = 0;
	uint duint;
	BYTE data[sizeTENZO] = {0};
	res = TENZO_Cmd_B3(addr, &data[0], repeat);
	duint = (uint)(data[0]);
	duint |= (((uint)(data[1]) << 8) & 0xFF00);
	duint |= (((uint)(data[2]) << 16) & 0xFF0000);
	set->mass_dose = (TENZO_BCDtoFLOAT(duint) / 100.0);
	printf("--- rd uint %u\r\n",duint);
	duint = (uint)(data[3]);
	duint |= (((uint)(data[4]) << 8) & 0xFF00);
	duint |= (((uint)(data[5]) << 16) & 0xFF0000);
	set->mass_porcion = (TENZO_BCDtoFLOAT(duint) / 100.0);
	duint = (uint)(data[6]);
	duint |= (((uint)(data[7]) << 8) & 0xFF00);
	duint |= (((uint)(data[8]) << 16) & 0xFF0000);
	set->mass_down_noprecesion = (TENZO_BCDtoFLOAT(duint) / 100.0);
	duint = (uint)(data[9]);
	duint |= (((uint)(data[10]) << 8) & 0xFF00);
	duint |= (((uint)(data[11]) << 16) & 0xFF0000);
	set->mass_down_precesion = (TENZO_BCDtoFLOAT(duint) / 100.0);
	duint = (uint)(data[12]);
	duint |= (((uint)(data[13]) << 8) & 0xFF00);
	//set->mass_delta_error = TENZO_BCDtoFLOAT(duint);
	set->mass_delta_error = (float)(duint);
	//
	return res;
}

int TV_009_WrSettings(BYTE addr, struct	_tv_009_set* set, int repeat)
{
	int res = 0;
	uint duint;
	BYTE data[sizeTENZO] = {0};
	duint = TENZO_FLOATtoBCD(set->mass_dose * 100.0);
	data[0] = (BYTE)(duint & 0xFF);
	data[1] = (BYTE)((duint >> 8) & 0xFF);
	data[2] = (BYTE)((duint >> 16) & 0xFF);
	printf("--- wr uint %u\r\n",duint);
	duint = TENZO_FLOATtoBCD(set->mass_porcion * 100.0);
	data[3] = (BYTE)(duint & 0xFF);
	data[4] = (BYTE)((duint >> 8) & 0xFF);
	data[5] = (BYTE)((duint >> 16) & 0xFF);
	duint = TENZO_FLOATtoBCD(set->mass_down_noprecesion * 100.0);
	data[6] = (BYTE)(duint & 0xFF);
	data[7] = (BYTE)((duint >> 8) & 0xFF);
	data[8] = (BYTE)((duint >> 16) & 0xFF);
	duint = TENZO_FLOATtoBCD(set->mass_down_precesion * 100.0);
	data[9] = (BYTE)(duint & 0xFF);
	data[10] = (BYTE)((duint >> 8) & 0xFF);
	data[11] = (BYTE)((duint >> 16) & 0xFF);
	duint = TENZO_FLOATtoBCD(set->mass_delta_error * 100.0);
	data[12] = (BYTE)(duint & 0xFF);
	data[13] = (BYTE)((duint >> 8) & 0xFF);
	res = TENZO_Cmd_B4(addr,&data[0], repeat);
	//
	return res;
}

int TV_009_OutStr(BYTE addr, char *str, int repeat)
{
	int res = 0;
	printf(str);
	res = TENZO_Cmd_D3(addr,str,repeat);
	return res;
}

void TV_009_SetOutStr(BYTE *str, char *instr)
{
	memset(str,0x20,10);
	memcpy(str,instr,10);
}

