//tv-011.c

#include <stdio.h>
#include "tv-011.h"
#include "tenzo-m.h"
#include "../types/types.h"


float TV_011_RdMass_brutto(BYTE addr, int repeat)
{
	float mb = -999.0;
	int res;
	int count = 0;
	BYTE data[8];
	//
	res = TENZO_Cmd_C3(addr,&data[0],repeat);
	if(res < 0)
		return mb;
	mb = TENZO_BCDtoFLOAT((*(uint*)(&data[0])));
	//
	return mb;
}



int TV_011_Start(BYTE addr, int repeat)
{
	int res = 0;
	res = TENZO_Cmd_DF_01(addr,repeat);
	return res;
}

int TV_011_Pause(BYTE addr, int repeat)
{
	int res = 0;
	res = TENZO_Cmd_DF_02(addr,repeat);
	return res;
}

int TV_011_Stop(BYTE addr, int repeat)
{
	int res = 0;
	res = TENZO_Cmd_DF_00(addr,repeat);
	return res;
}

int TV_011_RsCicle(BYTE addr, int repeat)
{
	int res = 0;
	res = TENZO_Cmd_DF_05(addr,repeat);
	return res;
}

int TV_011_NoPause(BYTE addr, int repeat)
{
	int res = 0;
	res = TENZO_Cmd_DF_03(addr,repeat);
	return res;
}

/*BYTE TV_O11_CloseUnload(BYTE def_outmask)
{
	return(def_outmask & (~(_out11_unload)));
}

BYTE TV_O11_OpenUnload(BYTE def_outmask)
{
	return(def_outmask | _out11_unload);
}*/

BYTE TV_O11_CloseUnload(BYTE def_outmask)
{
	return(def_outmask & (~(_out11_dose_load_noprecs)));
}

BYTE TV_O11_OpenUnload(BYTE def_outmask)
{
	return(def_outmask | _out11_dose_load_noprecs);
}

BYTE TV_O11_LampStopOFF(BYTE def_outmask)
{
	return(def_outmask & (~(_out11_stop)));
}

BYTE TV_O11_LampStopON(BYTE def_outmask)
{
	return(def_outmask | _out11_stop);
}


int TV_011_SetOutput(BYTE addr, BYTE def_outmask, int repeat)
{
	int res = 0;
	res = TENZO_Cmd_D0(addr,def_outmask, repeat);
	return res;
}

int TV_011_RdFull(BYTE addr, struct _tv_011_full_in* str, int repeat)
{
	int res = 0;
	int count = 0;


	BYTE data[sizeTENZO];
	res = TENZO_Cmd_CA(addr,_rd11_cpl, &data[0], repeat);

	str->mass = TENZO_BCDtoFLOAT((*(uint*)(&data[_addr11_mass])));
	str->inmask = data[_addr11_inp];
	str->outmask = data[_addr11_out];
	str->statmask = data[_addr11_stat];


	if(str->inmask & _in11_alrm)
		str->in_key_alrm = TRUE;
	else
		str->in_key_alrm = FALSE;

	if(str->inmask & _in11_start)
		str->in_key_start = TRUE;
	else
		str->in_key_start = FALSE;

	if(str->inmask & _in11_stop)
		str->in_key_stop = TRUE;
	else
		str->in_key_stop = FALSE;

	if(str->inmask & _in11_rs_err)
		str->in_key_rs_err = TRUE;
	else
		str->in_key_rs_err = FALSE;

	if(str->inmask & _in11_rs_cicle)
		str->in_key_rs_cicle = TRUE;
	else
		str->in_key_rs_cicle = FALSE;

	if(str->inmask & _in11_man)
		str->in_man = TRUE;
	else
		str->in_man = FALSE;

	if(str->inmask & _in11_unload_closed)
		str->in_closed_unload = TRUE;
	else
		str->in_closed_unload = FALSE;

	if(str->inmask & _in11_block)
		str->in_block = TRUE;
	else
		str->in_block = FALSE;

	//      ?


	if(str->outmask & _out11_alrm)
		str->out_alrm = TRUE;
	else
		str->out_alrm = FALSE;

	if(str->outmask & _out11_start)
		str->out_start = TRUE;
	else
		str->out_start = FALSE;

	if(str->outmask & _out11_stop)
		str->out_stop = TRUE;
	else
		str->out_stop = FALSE;

	if(str->outmask & _out11_dosed)
		str->out_dosed = TRUE;
	else
		str->out_dosed = FALSE;

	if(str->outmask & _out11_def_end)
		str->out_def_end = TRUE;
	else
		str->out_def_end = FALSE;

	if(str->outmask & _out11_dose_load_noprecs)
		str->out_dose_load_noprecs = TRUE;
	else
		str->out_dose_load_noprecs = FALSE;

	if(str->outmask & _out11_dose_load_precs)
		str->out_dose_load_precs = TRUE;
	else
		str->out_dose_load_precs = FALSE;

	if(str->outmask & _out11_unload)
		str->out_unload = TRUE;
	else
		str->out_unload = FALSE;



	if(str->statmask & _stat11_man)
		str->stat_man = TRUE;
	else
		str->stat_man = FALSE;

	if(str->statmask & _stat11_unload)
		str->stat_unload = TRUE;
	else
		str->stat_unload = FALSE;

	if(!(str->statmask & _stat11_fix_mass))
		str->stat_fix_mass = TRUE;
	else
		str->stat_fix_mass = FALSE;

	if(str->statmask & _stat11_pause_blck)
		str->stat_pause_blck = TRUE;
	else
		str->stat_pause_blck = FALSE;

	if(str->statmask & _stat11_end_dosator)
		str->stat_end_dosator = TRUE;
	else
		str->stat_end_dosator = FALSE;

	if(str->statmask & _stat11_stop)
		str->stat_stop = TRUE;
	else
		str->stat_stop = FALSE;

	if(str->statmask & _stat11_err)
		str->stat_err = TRUE;
	else
		str->stat_err = FALSE;

	if(str->statmask & _stat11_reg_dose)
		str->stat_reg_dose = TRUE;
	else
		str->stat_reg_dose = FALSE;


	return res;
}


//    !!!!

int TV_011_RdSettings(BYTE addr, struct	_tv_011_set* set, int repeat)
{
	int res = 0;
	uint duint;
	BYTE data[sizeTENZO] = {0};
	res = TENZO_Cmd_B3(addr, &data[0], repeat);

	duint = (uint)(data[0]);
	duint |= (((uint)(data[1]) << 8) & 0xFF00);
	duint |= (((uint)(data[2]) << 16) & 0xFF0000);
	set->mass_cycles = (TENZO_BCDtoFLOAT(duint) / 1.0);

	duint = (uint)(data[3]);
	duint |= (((uint)(data[4]) << 8) & 0xFF00);
	duint |= (((uint)(data[5]) << 16) & 0xFF0000);
	set->mass_otves = (TENZO_BCDtoFLOAT(duint) / 100.0);

	duint = (uint)(data[6]);
	duint |= (((uint)(data[7]) << 8) & 0xFF00);
	duint |= (((uint)(data[8]) << 16) & 0xFF0000);
	set->mass_add_enable = (TENZO_BCDtoFLOAT(duint) / 100.0);

	duint = (uint)(data[9]);
	duint |= (((uint)(data[10]) << 8) & 0xFF00);
	duint |= (((uint)(data[11]) << 16) & 0xFF0000);
	set->mass_add_disable = (TENZO_BCDtoFLOAT(duint) / 100.0);

	duint = (uint)(data[12]);
	duint |= (((uint)(data[13]) << 8) & 0xFF00);
	duint |= (((uint)(data[14]) << 16) & 0xFF0000);
	set->mass_noprecesion = (TENZO_BCDtoFLOAT(duint) / 1.0);

	duint = (uint)(data[15]);
	duint |= (((uint)(data[16]) << 8) & 0xFF00);
	duint |= (((uint)(data[17]) << 16) & 0xFF0000);
	set->mass_precesion = (TENZO_BCDtoFLOAT(duint) / 100.0);

	duint = (uint)(data[18]);
	duint |= (((uint)(data[19]) << 8) & 0xFF00);
	duint |= (((uint)(data[20]) << 16) & 0xFF0000);
	set->mass_dopusk = (TENZO_BCDtoFLOAT(duint) / 100.0);

	duint = (uint)(data[21]);
	duint |= (((uint)(data[22]) << 8) & 0xFF00);
	duint |= (((uint)(data[23]) << 16) & 0xFF0000);
	set->mass_empty = (TENZO_BCDtoFLOAT(duint) / 100.0);

	return res;
}



int TV_011_WrSettings(BYTE addr, struct	_tv_011_set* set, int repeat)
{
	int res = 0;
	uint duint;
	BYTE data[sizeTENZO] = {0};

	duint = TENZO_FLOATtoBCD(set->mass_cycles * 100.0);
	data[0] = (BYTE)(duint & 0xFF);
	data[1] = (BYTE)((duint >> 8) & 0xFF);
	data[2] = (BYTE)((duint >> 16) & 0xFF);

	duint = TENZO_FLOATtoBCD(set->mass_otves * 100.0);
	data[3] = (BYTE)(duint & 0xFF);
	data[4] = (BYTE)((duint >> 8) & 0xFF);
	data[5] = (BYTE)((duint >> 16) & 0xFF);

	duint = TENZO_FLOATtoBCD(set->mass_add_enable * 100.0);
	data[6] = (BYTE)(duint & 0xFF);
	data[7] = (BYTE)((duint >> 8) & 0xFF);
	data[8] = (BYTE)((duint >> 16) & 0xFF);

	duint = TENZO_FLOATtoBCD(set->mass_add_disable * 100.0);
	data[9] = (BYTE)(duint & 0xFF);
	data[10] = (BYTE)((duint >> 8) & 0xFF);
	data[11] = (BYTE)((duint >> 16) & 0xFF);

	duint = TENZO_FLOATtoBCD(set->mass_noprecesion * 100.0);
	data[12] = (BYTE)(duint & 0xFF);
	data[13] = (BYTE)((duint >> 8) & 0xFF);
	data[14] = (BYTE)((duint >> 16) & 0xFF);

	duint = TENZO_FLOATtoBCD(set->mass_precesion * 100.0);
	data[15] = (BYTE)(duint & 0xFF);
	data[16] = (BYTE)((duint >> 8) & 0xFF);
	data[17] = (BYTE)((duint >> 16) & 0xFF);

	duint = TENZO_FLOATtoBCD(set->mass_dopusk * 100.0);
	data[18] = (BYTE)(duint & 0xFF);
	data[19] = (BYTE)((duint >> 8) & 0xFF);
	data[20] = (BYTE)((duint >> 16) & 0xFF);

	duint = TENZO_FLOATtoBCD(set->mass_empty * 100.0);
	data[21] = (BYTE)(duint & 0xFF);
	data[22] = (BYTE)((duint >> 8) & 0xFF);
	data[23] = (BYTE)((duint >> 16) & 0xFF);

	res = TENZO_Cmd_B4(addr,&data[0], repeat);

	return res;
}

int TV_011_OutStr(BYTE addr, char *str, int repeat)
{
	int res = 0;
	printf(str);
	res = TENZO_Cmd_D3(addr,str,repeat);
	return res;
}

void TV_011_SetOutStr(BYTE *str, char *instr)
{
	memset(str,0x20,10);
	memcpy(str,instr,10);
}
